/*
**	Christophe Lucas <clucas@rotomalug.org>
**
**	Build x86 segmentation.
*/

#include <video/bochs.h>
#include <testos/errno.h>
#include <x86/segment.h>

static struct segment_descriptor_t gdt[] = {
	[SEG_NULL] = (struct segment_descriptor_t) { 0, },
	[SEG_KCODE] = BUILD_GDT_ENTRY(0, 1),
	[SEG_KDATA] = BUILD_GDT_ENTRY(0, 0),
};
	

ret_t setup_segmentation(void)
{
	struct gdtr_register_t gdtr;
	
	gdtr.base_address = (ui32_t) gdt ;
	gdtr.limit = sizeof(gdt) - 1 ;

	bochs_printf("Avant de mettre en place la GDT\n");

	asm volatile(
		"lgdt %0		\n\
		 ljmp %1, $1f		\n\
		 1:			\n\
		 movw %2, %%ax		\n\
		 movw %%ax, %%ds	\n\
		 movw %%ax, %%es	\n\
		 movw %%ax, %%fs	\n\
		 movw %%ax, %%gs"
		 :
		 : "m"(gdtr),  
		   "i"(BUILD_SEGMENT_SELECTOR(0, 0, SEG_KCODE)),
		   "i"(BUILD_SEGMENT_SELECTOR(0, 0, SEG_KDATA))
		 : "memory","eax" );

	bochs_printf("Aprs\n");
	return OK;
}
